<template>
  <div
    class="input-group"
    :class="$slots['button-append'] ? 'input-group-flat' : 'input-group-single'"
  >
    <div class="vue-select-rimow">
      <client-only>
        <v-select
          data-cy="select-parameter"
          v-bind="addProperties"
          :value="selected"
          :placeholder="placeholder"
          :options="options"
          :clearable="clearable"
          :multiple="multiple"
          :class="multiple ? 'v-select-multiple' : 'v-select-single'"
          label="title"
          :disabled="disabled"
          @input="handleChange"
          @search:focus="handleFocus"
          @search:blur="handleBlur"
        >
          <template #option="option">
            <span class="title mt-1 mr-2 ml-2">
              <component :is="itemIcon + '-icon'" class="icon-xxs" />
              <span class="name">
                {{ option.title }}
              </span>
              <span v-if="option.version" class="v">
                {{ option.version }}
              </span>
            </span>
            <span class="description ml-2">
              {{ option.description }}
            </span>
            <ul class="meta mb-2 ml-2">
              <li v-for="tag in option.tags" :key="tag.index" class="tags">
                <span>{{ tag }}</span>
              </li>
            </ul>
          </template>
          <template #selected-option="option">
            <div class="d-flex align-items-center mr-3 small">
              <span class="flex-child mt-0 mr-1 small">
                <component :is="itemIcon + '-icon'" class="mr-1 icon-xxs" />
                {{ option.title | truncateText(maxChars, '...') }}
              </span>
              <span v-if="option.version" class="v">{{ option.version }}</span>
            </div>
          </template>
          <template #open-indicator>
            <div></div>
          </template>
        </v-select>
      </client-only>
    </div>
    <template v-if="$slots['button-append']">
      <div class="input-group-append">
        <div
          class="btn-main-scenario-configure main-scenario-configure input-group-text pl-2 pr-2"
        >
          <slot name="button-append"></slot>
        </div>
      </div>
    </template>
  </div>
</template>

<script>
export default {
  props: {
    placeholder: {
      type: String,
      default: undefined,
    },
    itemIcon: {
      type: String,
      default: 'flame',
    },
    options: {
      type: Array,
      default: () => [],
    },
    selected: {
      type: [Object, Array, String],
      default: undefined,
    },
    clearable: {
      type: Boolean,
      default: true,
    },
    multiple: {
      type: Boolean,
      default: false,
    },
    maxChars: {
      type: Number,
      default: 17,
    },
    disabled: {
      type: Boolean,
      default: () => false,
    },
    addProperties: {
      type: Object,
      default: () => {},
    },
  },
  data() {
    return {
      isOpen: true,
    };
  },
  methods: {
    handleChange(value) {
      this.$emit('change', value);
    },
    handleFocus() {
      this.$emit('focus');
    },
    handleBlur() {
      this.$emit('blur');
    },
  },
};
</script>
